
Imports FUTURE.Charting
Imports Steema.TeeChart.Styles
Imports Steema.TeeChart

Public Class ChartHelper
    Private ReadOnly m_Chart As TChart

    Public ReadOnly SampleRowLabels As String() = {"Oil", "Water", "Produced Gas", "Lift Gas", "Liquid"}
    Public ReadOnly SampleColumnLabels As String() = {"Low Forecast", "Mid Forecast", "High Forecast", "Best Forecast", "Worst Forecast"}
    Public ReadOnly SampleColors As Color() = {Color.Red, Color.Green, Color.Blue, Color.Orange, Color.Magenta}

    Sub New(chart As TChart)
        m_Chart = chart
    End Sub

    Public Sub AddSeries(count As Integer)
        With m_Chart
            For index As Integer = 0 To count - 1
                'Even though we don't do anything explictly with line,
                'the constructor adds it the Chart.Series collection
                ' ReSharper disable UnusedVariable
                Dim line As FastLine = New FastLine(m_Chart.Chart)
                ' ReSharper restore UnusedVariable

                With m_Chart(index)
                    .FillSampleValues(10)
                    .XValues.DataMember = "X"
                    .YValues.DataMember = "Y"
                    .RefreshSeries()
                End With
            Next
        End With
    End Sub

    Public Sub AssignLegendSeries(rowCount As Integer, columnCount As Integer)
        For index As Integer = 0 To m_Chart.Series.Count - 1
            Dim rowIndex As Integer = ((index \ columnCount) Mod rowCount) + 1
            Dim columnIndex As Integer = (index Mod columnCount) + 1
            Dim line As FastLine = CType(m_Chart.Series(index), FastLine)
            line.Tag = New LegendSeries(rowIndex, columnIndex)
        Next
    End Sub
End Class
