﻿Imports System.Runtime.CompilerServices

Namespace Charting

    Public Module ControlExtensions
        Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Integer,
                                                                        ByVal wMsg As Integer,
                                                                        ByVal wParam As Integer,
                                                                        ByVal lParam As Integer) As Integer
        Private Const WM_SETREDRAW As Integer = 11

        ' Extension methods for Control
        <Extension()>
        Public Sub ResumeDrawing(ByVal target As Control, ByVal redraw As Boolean)
            SendMessage(CType(target.Handle, Integer), WM_SETREDRAW, 1, 0)
            If Redraw Then
                target.Refresh()
            End If
        End Sub

        <Extension()>
        Public Sub SuspendDrawing(ByVal target As Control)
            SendMessage(CType(target.Handle, Integer), WM_SETREDRAW, 0, 0)
        End Sub

        <Extension()>
        Public Sub ResumeDrawing(ByVal target As Control)
            Target.ResumeDrawing(True)
        End Sub
    End Module
End Namespace