﻿

Namespace Charting
    Partial Class Legend2D

        ''' <summary>
        ''' Helper class for accessing the properties of a logical row in a Legend2D
        ''' </summary>
        Public Class LegendColumn
            Private ReadOnly m_Legend As ILegend
            Private ReadOnly m_Column As Integer

            ''' <summary>
            ''' Create a new LegendColumn
            ''' </summary>
            ''' <param name="legend">The associated Legend2D instance</param>
            ''' <param name="column">1-based index of the row</param>
            ''' <remarks>
            ''' The LegendColumn consructor is typically only used by the Legend2D object itself
            ''' </remarks>
            Public Sub New(legend As ILegend, column As Integer)
                m_Legend = legend
                m_Column = column
            End Sub

            ''' <summary>
            ''' Returns true if any series for this column are visible, false otherwise
            ''' </summary>
            Public Property Visible As Boolean
                Get
                    Return m_Legend.ColumnVisible(m_Column)
                End Get
                Set(value As Boolean)
                    m_Legend.ColumnVisible(m_Column) = value
                End Set
            End Property
        End Class
    End Class
End Namespace
